#ifndef SSL_H
#define SSL_H

#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/x509.h>
#include <openssl/pem.h>

#include "config.h"

SSL_CTX* InitServerCTX(Config *config);

EVP_PKEY* generate_ca_key();
X509* generate_ca_cert(EVP_PKEY * pkey);
bool create_and_save_key(char keyfile[]);
bool create_and_save_cert(char keyfile[], EVP_PKEY *pkey);
EVP_PKEY* read_private_key(char keyfile[]);

#endif /* ifndef SSL_ */
